// naumann@stce.rwth-aachen.de

#pragma once

#include <vector> 
#include <limits>

#include "data.hpp"

/**
 * The model.
 */
template<typename T>
class model {
  const data<T>& d;
  const T eps=std::numeric_limits<T>::epsilon();
  T p;
  std::string filename;
  T mse() const; 
  T d_mse();
  T dd_mse();
public:
  model(const data<T>&, char*);
  ~model();
  T evaluate(T) const;
  void calibrate();
  void plot() const;
};

#include "model.cpp"
